// Copyright (c) 2006 Advanced Micro Devices ("AMD").
//
// All Rights Reserved.  Unpublished rights reserved under the 
// copyright laws of the United States of America, other countries 
// and international treaties.  The software is provided without 
// fee.  Permission to use, copy, store, modify, disclose, transmit 
// or distribute the software is granted, provided that this 
// copyright notice must appear in any copy, modification, 
// disclosure, transmission or distribution of the software.
//
// AMD retains all ownership, copyright, trade secret and 
// proprietary rights in the software. THIS SOFTWARE HAS BEEN 
// PROVIDED "AS IS," WITHOUT EXPRESS OR IMPLIED WARRANTY INCLUDING, 
// WITHOUT LIMITATION, IMPLIED WARRANTIES OF MERCHANTABILITY, 
// FITNESS FOR A PARTICULAR USE AND NON-INFRINGEMENT.
//
// AMD does not assume or authorize any other person to assume for 
// it any liability in connection with the Software. AMD SHALL NOT 
// BE LIABLE TO COMPANY, OR ANY THIRD PARTY, IN CONTRACT, TORT, 
// WARRANTY, STRICT LIABILITY, OR OTHERWISE FOR ANY DIRECT DAMAGES, 
// OR FOR ANY SPECIAL, INDIRECT, INCIDENTAL OR CONSEQUENTIAL 
// DAMAGES, INCLUDING BUT NOT LIMITED TO, BUSINESS INTERRUPTION, 
// LOST PROFITS OR GOODWILL, OR LOSS OF INFORMATION EVEN IF AMD IS 
// ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
//
#include "stdafx.h"
#include "lx_gtf.h"
#include "lx_gtfDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CLX_GTFApp
//
BEGIN_MESSAGE_MAP(CLX_GTFApp, CWinApp)
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()


// CLX_GTFApp construction
//
CLX_GTFApp::CLX_GTFApp()
{
	EnableHtmlHelp();
}


// The one and only CLX_GTFApp object
//
CLX_GTFApp theApp;


// CLX_GTFApp initialization
//
BOOL CLX_GTFApp::InitInstance()
{
	// InitCommonControls() is required on Windows XP if an application
	// manifest specifies use of ComCtl32.dll version 6 or later to enable
	// visual styles.  Otherwise, any window creation will fail.
    //
	InitCommonControls();

	CWinApp::InitInstance();

	AfxEnableControlContainer();

	CLX_GTFDlg dlg;
	m_pMainWnd = &dlg;
	INT_PTR nResponse = dlg.DoModal();

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
    //
	return FALSE;
}
