#include "cim_parm.h"

typedef struct tagDEFINE_STRING
{
    char *define_string;
    unsigned long value;
} DEFINE_STRING;

DEFINE_STRING ValidDefines[] = 
{
    { "DF_DISPLAY_CRT",                     DF_DISPLAY_CRT },
    { "DF_DISPLAY_CRT_DRGB",                DF_DISPLAY_CRT_DRGB },
    { "DF_DISPLAY_CRT_FP",                  DF_DISPLAY_CRT_FP },
    { "DF_DISPLAY_DRGB",                    DF_DISPLAY_DRGB },
    { "DF_DISPLAY_FP",                      DF_DISPLAY_FP },
    { "DF_DISPLAY_VOP",                     DF_DISPLAY_VOP },
    { "DF_OUTPUT_ARGB",                     DF_OUTPUT_ARGB },
    { "DF_OUTPUT_HDTV",                     DF_OUTPUT_HDTV },
    { "DF_OUTPUT_RGB",                      DF_OUTPUT_RGB },
    { "DF_OUTPUT_SDTV",                     DF_OUTPUT_SDTV },
    { "VG_FLICKER_FILTER_1_16",             VG_FLICKER_FILTER_1_16 },
    { "VG_FLICKER_FILTER_1_4",              VG_FLICKER_FILTER_1_4 },
    { "VG_FLICKER_FILTER_1_8",              VG_FLICKER_FILTER_1_8 },
    { "VG_FLICKER_FILTER_5_16",             VG_FLICKER_FILTER_5_16 },
    { "VG_FLICKER_FILTER_NONE",             VG_FLICKER_FILTER_NONE },
    { "VG_MODEFLAG_AVG_BAND",               VG_MODEFLAG_AVG_BAND },
    { "VG_MODEFLAG_CENTERED",               VG_MODEFLAG_CENTERED },
    { "VG_MODEFLAG_CRT_AND_FP",             VG_MODEFLAG_CRT_AND_FP },
    { "VG_MODEFLAG_CUSTOM_PANEL",           VG_MODEFLAG_CUSTOM_PANEL },
    { "VG_MODEFLAG_EXCLUDEPLL",             VG_MODEFLAG_EXCLUDEPLL },
    { "VG_MODEFLAG_HALFCLOCK",              VG_MODEFLAG_HALFCLOCK },
    { "VG_MODEFLAG_HIGH_BAND",              VG_MODEFLAG_HIGH_BAND },
    { "VG_MODEFLAG_INTERLACED",             VG_MODEFLAG_INTERLACED },
    { "VG_MODEFLAG_INT_ADDRESS",            VG_MODEFLAG_INT_ADDRESS },
    { "VG_MODEFLAG_INT_FLICKER",            VG_MODEFLAG_INT_FLICKER },
    { "VG_MODEFLAG_INT_LINEDOUBLE",         VG_MODEFLAG_INT_LINEDOUBLE },
    { "VG_MODEFLAG_INVERT_SHFCLK",          VG_MODEFLAG_INVERT_SHFCLK },
    { "VG_MODEFLAG_LEGACY_BAND",            VG_MODEFLAG_LEGACY_BAND },
    { "VG_MODEFLAG_LINEARPITCH",            VG_MODEFLAG_LINEARPITCH },
    { "VG_MODEFLAG_LOW_BAND",               VG_MODEFLAG_LOW_BAND },
    { "VG_MODEFLAG_MANUAL_FREQUENCY",       VG_MODEFLAG_MANUAL_FREQUENCY },
    { "VG_MODEFLAG_NEG_HSYNC",              VG_MODEFLAG_NEG_HSYNC },
    { "VG_MODEFLAG_NEG_VSYNC",              VG_MODEFLAG_NEG_VSYNC },
    { "VG_MODEFLAG_NOPANELTIMINGS",         VG_MODEFLAG_NOPANELTIMINGS },
    { "VG_MODEFLAG_PANELOUT",               VG_MODEFLAG_PANELOUT },
    { "VG_MODEFLAG_PLL_BYPASS",             VG_MODEFLAG_PLL_BYPASS },
    { "VG_MODEFLAG_QVGA",                   VG_MODEFLAG_QVGA },
    { "VG_MODEFLAG_TVOUT",                  VG_MODEFLAG_TVOUT },
    { "VG_MODEFLAG_VIP_TO_DOT_CLOCK",       VG_MODEFLAG_VIP_TO_DOT_CLOCK },
    { "VG_MODEFLAG_XVGA_TFT",               VG_MODEFLAG_XVGA_TFT },
    { "VOP_422MODE_ALTERNATING",            VOP_422MODE_ALTERNATING },
    { "VOP_422MODE_COSITED",                VOP_422MODE_COSITED },
    { "VOP_422MODE_INTERSPERSED",           VOP_422MODE_INTERSPERSED },
    { "VOP_601_INVERT_DISPE",               VOP_601_INVERT_DISPE },
    { "VOP_601_INVERT_HSYNC",               VOP_601_INVERT_HSYNC },
    { "VOP_601_INVERT_VSYNC",               VOP_601_INVERT_VSYNC },
    { "VOP_601_RGB_8_8_8",                  VOP_601_RGB_8_8_8 },
    { "VOP_601_YUV_16BIT",                  VOP_601_YUV_16BIT },
    { "VOP_601_YUV_4_4_4",                  VOP_601_YUV_4_4_4 },
    { "VOP_601_YUV_8BIT",                   VOP_601_YUV_8BIT },
    { "VOP_FLAG_EXTENDEDSAV",               VOP_FLAG_EXTENDEDSAV },
    { "VOP_FLAG_SINGLECHIPCOMPAT",          VOP_FLAG_SINGLECHIPCOMPAT },
    { "VOP_FLAG_SWAP_UV",                   VOP_FLAG_SWAP_UV },
    { "VOP_FLAG_SWAP_VBI",                  VOP_FLAG_SWAP_VBI },
    { "VOP_FLAG_TASK",                      VOP_FLAG_TASK },
    { "VOP_FLAG_VBI",                       VOP_FLAG_VBI },
    { "VOP_MB_SYNCSEL_DISABLED",            VOP_MB_SYNCSEL_DISABLED },
    { "VOP_MB_SYNCSEL_STATREG17",           VOP_MB_SYNCSEL_STATREG17 },
    { "VOP_MB_SYNCSEL_STATREG17_INV",       VOP_MB_SYNCSEL_STATREG17_INV },
    { "VOP_MB_SYNCSEL_VG",                  VOP_MB_SYNCSEL_VG },
    { "VOP_MB_SYNCSEL_VG_INV",              VOP_MB_SYNCSEL_VG_INV },
    { "VOP_MODE_601",                       VOP_MODE_601 },
    { "VOP_MODE_CCIR656",                   VOP_MODE_CCIR656 },
    { "VOP_MODE_DISABLED",                  VOP_MODE_DISABLED },
    { "VOP_MODE_VIP11",                     VOP_MODE_VIP11 },
    { "VOP_MODE_VIP20_16BIT",               VOP_MODE_VIP20_16BIT },
    { "VOP_MODE_VIP20_8BIT",                VOP_MODE_VIP20_8BIT },
    { "VOP_VSYNC_EARLIER_BY2",              VOP_VSYNC_EARLIER_BY2 },
    { "VOP_VSYNC_EARLIER_BY4",              VOP_VSYNC_EARLIER_BY4 },
    { "VOP_VSYNC_LATER_BY_X",               VOP_VSYNC_LATER_BY_X },
    { "VOP_VSYNC_NOSHIFT",                  VOP_VSYNC_NOSHIFT }
};

unsigned long g_NumDefines = (sizeof(ValidDefines) / sizeof(DEFINE_STRING));

#define GET_SETTING(base, setting, pOut)                                                    \
{                                                                                           \
    if (!NextToken (filetext, token1)) return 0;                                            \
    if (!NextToken (filetext, token2)) return 0;                                            \
    if (!NextToken (filetext, token3)) return 0;                                            \
                                                                                            \
    if (token1 != base)                                                                     \
    {                                                                                       \
        printf ("Error on line %i - Expected %s  Read %s\n", g_line, base, token1);         \
        goto cleanUp;                                                                       \
    }                                                                                       \
    if (token2 != setting)                                                                  \
    {                                                                                       \
        printf ("Error on line %i - Expected %s  Read %s\n", g_line, setting, token2);      \
        goto cleanUp;                                                                       \
    }                                                                                       \
    if (token3 == "(")                                                                      \
    {                                                                                       \
        *(pOut) = 0;                                                                        \
        while (1)                                                                           \
        {                                                                                   \
            if (!NextToken (filetext, token3)) return 0;                                    \
            if (token3 == ")") break;                                                       \
            if (token3 != "|") *(pOut) |= (unsigned long)(ExtractValue (&token3));          \
        }                                                                                   \
    }                                                                                       \
    else                                                                                    \
    {                                                                                       \
        *(pOut) = (unsigned long)(ExtractValue (&token3));                                  \
    }                                                                                       \
}

#define WRITE_LINE(string)                                          \
{                                                                   \
    oneLine.Format string;                                          \
    inf_file.Write (oneLine.GetBuffer(1), oneLine.GetLength());     \
}

int FindDefine (char *var_string);
void DisplayUsage (void);
int NextToken (CString& input, CString& token);
long ExtractValue (CString *pString);
void WriteInfFile (CFile& inf_file, CString& filename, CString &disk_id, 
    CString& bin_file, ULONG fileSize);