//
// <LIC_AMD_STD>
// Copyright (C) <years> Advanced Micro Devices, Inc.  All Rights Reserved.
// </LIC_AMD_STD>
//
// <CTL_AMD_STD>
// </CTL_AMD_STD>
//
// <DOC_AMD_STD>
// DXAPI routine definitions.
// </DOC_AMD_STD>
//

DWORD LXGetIRQInfo (
    PVOID           HwDeviceExtension,
    PVOID           lpInput,
    PDDGETIRQINFO   GetIRQInfo);

DWORD LXEnableIRQ (
    PHW_DEVICE_EXTENSION    HwDeviceExtension,
    PDDENABLEIRQINFO        EnableIRQInfo,
    PVOID                   lpOutput);

DWORD LXSkipNextField (
    PVOID                   HwDeviceExtension,
    PDDSKIPNEXTFIELDINFO    SkipNextFieldInfo,
    PVOID                   lpOutput);

DWORD LXBobNextField (
    PHW_DEVICE_EXTENSION    HwDeviceExtension,
    PDDBOBNEXTFIELDINFO     BobNextFieldInfo,
    PVOID                   lpOutput);

DWORD LXSetState (
    PVOID               HwDeviceExtension,
    PDDSETSTATEININFO   SetStateInInfo,
    PDDSETSTATEOUTINFO  SetStateOutInfo);

DWORD LXLock (
    PVOID               HwDeviceExtension,
    PDDLOCKININFO       LockInInfo,
    PDDLOCKOUTINFO      LockOutInfo);

DWORD LXFlipOverlay (
    PHW_DEVICE_EXTENSION    HwDeviceExtension,
    PDDFLIPOVERLAYINFO      FlipOverlayInfo,
    PVOID                   lpOutput);

DWORD LXFlipVideoPort (
    PHW_DEVICE_EXTENSION  HwDeviceExtension,
    PDDFLIPVIDEOPORTINFO  FlipVideoPortInfo,
    PVOID                 lpOutput);

DWORD LXGetPolarity (
    PHW_DEVICE_EXTENSION    HwDeviceExtension,
    PDDGETPOLARITYININFO    GetPolarityInInfo,
    PDDGETPOLARITYOUTINFO   GetPolarityOutInfo);

DWORD LXGetCurrentAutoFlip (
    PHW_DEVICE_EXTENSION            HwDeviceExtension,
    PDDGETCURRENTAUTOFLIPININFO     GetCurrentAutoFlipInInfo,
    PDDGETCURRENTAUTOFLIPOUTINFO    GetCurrentAutoFlipOutInfo);

DWORD LXGetPreviousAutoFlip (
    PHW_DEVICE_EXTENSION            HwDeviceExtension,
    PDDGETPREVIOUSAUTOFLIPININFO    GetPreviousAutoFlipInInfo,
    PDDGETPREVIOUSAUTOFLIPOUTINFO   GetPreviousAutoFlipOutInfo);

ULONG FindAutoFlipIndex (
    PHW_DEVICE_EXTENSION    HwDeviceExtension,
    ULONG                   OverlayOffset);


